package com.unitesk.requality.eclipse.views;

import org.eclipse.core.runtime.Assert;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.views.properties.tabbed.AbstractPropertySection;
import org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetPage;
import org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetWidgetFactory;

import com.unitesk.requality.eclipse.views.properties.*;
import com.unitesk.requality.nodetypes.Requirement;

public class MainPropertySection extends AbstractPropertySection {
    private AttributesPanel attribPane;
    private Text textId;
    private Text textName;
    
    private Requirement req;
    public MainPropertySection() {
    }

    @Override
    public void createControls(Composite parent,
            TabbedPropertySheetPage aTabbedPropertySheetPage) {
        super.createControls(parent, aTabbedPropertySheetPage);
        parent.setLayoutData(new GridData(GridData.FILL_BOTH));
        GridData rightCol = new GridData(GridData.FILL_HORIZONTAL);
        parent.setLayout(new GridLayout(2, false));
        TabbedPropertySheetWidgetFactory wf = getWidgetFactory();
        wf.createLabel(parent, "Id:");
        textId = wf.createText(parent, "hello", SWT.BORDER);
        textId.setLayoutData(rightCol);
        wf.createLabel(parent, "name:");
        textName = wf.createText(parent, "node name", SWT.BORDER);
        textName.setLayoutData(rightCol);
        attribPane = new AttributesPanel(parent, wf);
        GridData ld = new GridData(GridData.FILL_BOTH);
        ld.horizontalSpan=2;
        attribPane.getControl().setLayoutData(ld);
        parent.pack();
    }
    
    @Override
    public void setInput(IWorkbenchPart part, ISelection selection) {
        super.setInput(part, selection);
        Assert.isTrue(selection instanceof IStructuredSelection);
        IStructuredSelection sel = (IStructuredSelection) selection;
        if (sel.getFirstElement() instanceof Requirement) {
            req = (Requirement) sel.getFirstElement();
        }
    }

    @Override
    public void refresh() {
        super.refresh();
        if(req!=null) {
//            mainPanel.setRequirement(req);
        }
    }
}
