///*
// * Copyright 2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
// *
// * Licensed under the Apache License, Version 2.0 (the "License");
// * you may not use this file except in compliance with the License.
// * You may obtain a copy of the License at
// *
// *     http://www.apache.org/licenses/LICENSE-2.0
// *
// * Unless required by applicable law or agreed to in writing, software
// * distributed under the License is distributed on an "AS IS" BASIS,
// * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// * See the License for the specific language governing permissions and
// * limitations under the License.
// */
//
//package com.unitesk.requality.eclipse.views.documents;
//
//import org.eclipse.jface.action.IMenuListener;
//import org.eclipse.jface.action.IMenuManager;
//import org.eclipse.jface.action.MenuManager;
//import org.eclipse.jface.viewers.DoubleClickEvent;
//import org.eclipse.jface.viewers.IContentProvider;
//import org.eclipse.jface.viewers.IDoubleClickListener;
//import org.eclipse.jface.viewers.ILabelProvider;
//import org.eclipse.jface.viewers.ISelection;
//import org.eclipse.jface.viewers.IStructuredSelection;
//import org.eclipse.jface.viewers.Viewer;
//import org.eclipse.jface.viewers.ViewerComparator;
//import org.eclipse.swt.widgets.Menu;
//import org.eclipse.ui.IWorkbenchPage;
//import org.eclipse.ui.PartInitException;
//import org.eclipse.ui.PlatformUI;
//
//import com.unitesk.requality.eclipse.editors.DocEditorInput;
//import com.unitesk.requality.eclipse.views.TreesContentProvider;
//import com.unitesk.requality.eclipse.views.TreesView;
//import com.unitesk.requality.nodetypes.DocFolder;
//import com.unitesk.requality.nodetypes.Document;
//
//public class DocCatalogueView extends TreesView {
//    public static final String ID = "com.unitesk.requality.views.DocCatalogueView";
//
//    private IDoubleClickListener doubleClickListener = new IDoubleClickListener() {
//        @Override
//        public void doubleClick(DoubleClickEvent event) {
//            ISelection selection = tree.getSelection();
//            Object obj = ((IStructuredSelection) selection).getFirstElement();
//            if (obj instanceof Document) {
//                Document doc = (Document) obj;
//                IWorkbenchPage page = PlatformUI.getWorkbench()
//                        .getActiveWorkbenchWindow().getActivePage();
//                if (page != null) {
//                    try {
//                        page.openEditor(
//                                new DocEditorInput(doc, null),
//                                "com.unitesk.requality.editors.browser.ReqMarker",
//                                true);
//                    } catch (PartInitException e) {
//                        e.printStackTrace();
//                    }
//                }
//            }
//        }
//    };
//
//    public DocCatalogueView() {
//
//    }
//
//    protected void hookContextMenu() {
//        MenuManager menuMgr = new MenuManager("#PopupMenu");
//        menuMgr.setRemoveAllWhenShown(true);
//        menuMgr.addMenuListener(new IMenuListener() {
//            public void menuAboutToShow(IMenuManager manager) {
//                DocCatalogueView.this.fillContextMenu(manager);
//            }
//        });
//
//        Menu menu = menuMgr.createContextMenu(tree.getControl());
//        tree.getControl().setMenu(menu);
//        getSite().registerContextMenu(menuMgr, tree);
//    }
//
//    private void fillContextMenu(IMenuManager manager) {
////        manager.add(new ImportAction(this));
//
//        // Other plug-ins can contribute there actions here
//    }
//
//    @Override
//    protected IContentProvider createContentProvider() {
//        TreesContentProvider result = new TreesContentProvider(Document.getTypeRootQId());
//        result.setSupportedTypes(getTypes());
//        return result;
//       
//    }
//
//    @Override
//    protected ILabelProvider createLabelProvider() {
//        return new DocLabelProvider();
//    }
//
//    @Override
//    protected void makeActions() {
//        // TODO Auto-generated method stub
//        
//    }
//
//    @Override
//    protected void hookDoubleClickAction() {
//        tree.addDoubleClickListener(doubleClickListener);
//    }
//
//    @Override
//    protected void contributeToActionBars() {
//        // TODO Auto-generated method stub
//    }
//
//    @Override
//    protected String[] getTypes() {
//        return new String[]{"DocFolder", "Document"};
//    }
//
//    @Override
//    protected ViewerComparator getViewerComparator() {
//        return new ViewerComparator() {
//            @Override
//            public int compare(Viewer viewer, Object e1, Object e2) {
//                if (e1 instanceof DocFolder) {
//                    if(e2 instanceof Document) {
//                        return -1;
//                    }
//                }
//                if (e1 instanceof Document) {
//                    if(e2 instanceof DocFolder) {
//                        return 1;
//                    }
//                }
//                return super.compare(viewer, e1, e2);
//            }
//        };
//    }
//
//}
