package com.unitesk.requality.eclipse.views.filters;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.tools.TreesTracker;

public abstract class AbstractNodeFilter extends ViewerFilter {

    public AbstractNodeFilter() {
        super();
    }

    protected String getSelectionType(Object element) {
        if (element instanceof IFile) {
            IFile file = (IFile) element;
            return TreesTracker.getNodeByResource(file).getType();
        }
        if (element instanceof TreeNode) {
            TreeNode node = (TreeNode) element;
            return node.getType();
        }
        return null;
    }

    @Override
    public boolean select(Viewer viewer, Object parentElement, Object element) {
        String type = getSelectionType(element);
        if(type==null) return true;
        for(String t : getFilterTypes()) {
            if (type.equals(t)) {
                return false;
            }
        }
        return true;
    }

    abstract protected String[] getFilterTypes();
}