package com.unitesk.requality.eclipse.views.properties;

import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.jface.viewers.TextCellEditor;
import org.eclipse.jface.viewers.ViewerSorter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetWidgetFactory;

public class AttributesPanel {
    private Composite panel;
    private static final String columnNames[] = new String[] { "Name", "Value" };
//    private Map<String, String> attributes;
//    private Map<String, String> innerAttr= new HashMap<String, String>();
    private TableViewer attribTable;

    public AttributesPanel(Composite parent, TabbedPropertySheetWidgetFactory wf) {
        panel = wf.createComposite(parent, SWT.NONE);
        panel.setLayout(new GridLayout(2, false));
        panel.setLayoutData(new GridData(GridData.FILL_BOTH));
        GridData span2 = new GridData();
        span2.horizontalSpan=2;
        wf.createLabel(panel, "Attributes:").setLayoutData(span2);

        attribTable = new TableViewer(panel);
        attribTable.setSorter(new ViewerSorter());
        attribTable.getControl().setLayoutData(new GridData(GridData.FILL_BOTH));
        // Create columns
        for (String colName : columnNames) {
            TableViewerColumn column = new TableViewerColumn(attribTable, SWT.H_SCROLL | SWT.V_SCROLL);
            column.getColumn().setText(colName);
            column.getColumn().setWidth(100);
            column.getColumn().setResizable(true);
            column.getColumn().setMoveable(true);
        }
        attribTable.setColumnProperties(columnNames);
        attribTable.getTable().setHeaderVisible(true);
        attribTable.getTable().setLinesVisible(true);

        // Editors
        CellEditor[] editors = new CellEditor[columnNames.length];
        editors[0] = new TextCellEditor(attribTable.getTable());
        editors[1] = new TextCellEditor(attribTable.getTable());
        attribTable.setCellEditors(editors);
    }
    public Control getControl() {
        return panel;
    }
}
