package com.unitesk.requality.tests.core;

import static org.junit.Assert.assertEquals;

import org.json.JSONObject;
import org.junit.Test;

import com.unitesk.requality.core.Attribute;
import com.unitesk.requality.core.MemoryStorage;
import com.unitesk.requality.core.NodeMapper;
import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;

public class NodeJSON {
    @Test
    public void makeJSONFile() throws Exception {
        TreeDB db1 = new TreeDB(new MemoryStorage());
        TreeNode node = db1.getRootNode().createChild("node");
        node.setPredicate("true");
        node.setDescription("Hello, world");
        node.addBaseNode("/hello");
        node.addBaseNode("/hello/World");
        node.saveAttributes();
        JSONObject json = NodeMapper.toJSON(node);
        NodeMapper mapper = new NodeMapper(json.toString(4));
        // Mapper test
        assertEquals(node.getUUId(), mapper.getUUId());
        assertEquals(node.getAttributeKeys().size(), mapper.getAttributes().size());
        for(Attribute a: mapper.getAttributes()) {
            assertEquals(node.getAttributeValue(a.getKey()), a.getValue());
        }
    }
}
