package swtbotforrequality;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import org.eclipse.swtbot.eclipse.finder.SWTWorkbenchBot;
import org.eclipse.swtbot.eclipse.finder.widgets.SWTBotEditor;
import org.eclipse.swtbot.swt.finder.SWTBot;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotMenu;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotShell;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotText;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotTree;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotTreeItem;
import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;


public class RenameRequirement {
	private static SWTWorkbenchBot	bot;
	 
	@BeforeClass
	public static void beforeClass() throws Exception {
		bot = new SWTWorkbenchBot();
		//---
//		bot.viewByTitle("Welcome").close();
//		bot.menu("File").menu("New").menu("Other...").click();
//		 
//		SWTBotShell shell = bot.shell("New");
//		shell.activate();
//		bot.tree().expandNode("Requality").select("Requality Project");
//		bot.button("Next >").click();
//		bot.textWithLabel("Project name:").setText("ReqProject");
//		bot.button("Finish").click();
//		bot.activeView();
		//---
	}
 
 
	@Test
	public void canRenameRequirement() throws Exception {
		SWTBotTree tree = bot.viewByTitle("Requality Explorer").bot().tree();
		tree.expandNode("ReqProject").select("Requirements");
		ContextMenuHelper.clickContextMenu(tree, "Add Requirement...");
		tree.expandNode("ReqProject").expandNode("Requirements").select("01").click();
		SWTBot reqEditor = bot.editorByTitle("01").bot();
		reqEditor.checkBox().select();
		SWTBotText name = reqEditor.text("01", 1);
		assertTrue("Text field with label 'Name:' is disabled", name.isEnabled());
		name.setText("new name");
		bot.shell("Requality - Requirement - Eclipse Platform");
		bot.menu("File").menu("Save All").click();
		boolean ok = false;
		for( SWTBotEditor ed: bot.editors()) {
			if(ed.getTitle().equals("new name")) {
				ok = true;
				break;
			}
		}
		assertTrue("There is no 'new name' editor", ok);
		reqEditor = bot.editorByTitle("new name").bot();
		assertEquals("Name of requirement is not 'new name'","new name",name.getText());
	}
 
 
	@AfterClass
	public static void sleep() {
		bot.sleep(2000);
	}
}
